/* Prints a formatted string. The *e-terminated string fmt is printed to
 * standard output, except that escapes of the form %x process the next unused
 * argument as follows.
 *
 * %c prints a character.
 * %d prints an integer in decimal.
 * %o prints an integer in octal.
 * %s prints a string.
 */

printf(fmt, a1) {
   extrn char, printn, putchar;
   auto i, c, p, a, j;

   p = &a1;
   i = 0;
loop:
   while ((c = char(fmt, i++)) != '*e') {
      if (c == '%') {
         a = *p++;
         c = 10;
         switch (char(fmt, i++)) {
         case 'c':
            putchar(a);
            goto loop;
         case 'o':
             c = 8;
         case 'd':
            if (a < 0) {
               putchar('-');
               a = -a;
            }
            printn(a, c);
            goto loop;
         case 's':
            j = 0;
            while ((c = char(a, j++)) != '*e')
               putchar(c);
            goto loop;
         }
         putchar('%');
         --p;
         --i;
      } else {
         putchar(c);
      }
   }
}
